scala

# Enumeration

###
Related Doc: package scala

#### abstract class Enumeration extends Serializable

Defines a finite set of values specific to the enumeration. Typically these values enumerate all possible forms something can take and provide a lightweight alternative to case classes.

Each call to a `Value` method adds a new unique value to the enumeration. To be accessible, these values are usually defined as `val` members of the evaluation.

All values in an enumeration share a common, unique type defined as the `Value` type member of the enumeration (`Value` selected on the stable identifier path of the enumeration instance).

Self Type
  Enumeration
Annotations
  @SerialVersionUID()
Source
  Enumeration.scala
Example:

1.     object Main extends App {
         object WeekDay extends Enumeration {
           type WeekDay = Value
           val Mon, Tue, Wed, Thu, Fri, Sat, Sun = Value
         }
         import WeekDay._
         def isWorkingDay(d: WeekDay) = ! (d == Sat || d == Sun)
         WeekDay.values filter isWorkingDay foreach println
       }
       // output:
       // Mon
       // Tue
       // Wed
       // Thu
       // Fri

Linear Supertypes
Serializable, java.io.Serializable, AnyRef, Any
Known Subclasses
RoundingMode
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Enumeration
2. Serializable
3. Serializable
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Enumeration()

2. #### new Enumeration(initial: Int)

   initial

     The initial value from which to count the integers that identifies values at run-time.

### Type Members

1. #### class Val extends Value with Serializable

   A class implementing the scala.Enumeration.Value type.

   A class implementing the scala.Enumeration.Value type. This class can be overridden to change the enumeration's naming and integer identification behaviour.

   Attributes
     protected
   Annotations
     @SerialVersionUID()

2. #### abstract class Value extends Ordered[Value] with Serializable

   The type of the enumerated values.

   The type of the enumerated values.

   Annotations
     @SerialVersionUID()

3. #### class ValueSet extends AbstractSet[Value] with SortedSet[Value] with SortedSetLike[Value, ValueSet] with Serializable

   A class for sets of values.

   A class for sets of values. Iterating through this set will yield values in increasing order of their ids.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Enumeration to any2stringadd[Enumeration] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Enumeration, B)

   Implicit information
     This member is added by an implicit conversion from Enumeration to ArrowAssoc[Enumeration] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def Value(i: Int, name: String): Value

   Creates a fresh value, part of this enumeration, called `name` and identified by the integer `i`.

   Creates a fresh value, part of this enumeration, called `name` and identified by the integer `i`.

   i

     An integer that identifies this value at run-time. It must be unique amongst all values of the enumeration.

   name

     A human-readable name for that value.

   returns

     Fresh value with the provided identifier `i` and name `name`.

   Attributes
     protected

7. #### final def Value(name: String): Value

   Creates a fresh value, part of this enumeration, called `name`.

   Creates a fresh value, part of this enumeration, called `name`.

   name

     A human-readable name for that value.

   returns

     Fresh value called `name`.

   Attributes
     protected

8. #### final def Value(i: Int): Value

   Creates a fresh value, part of this enumeration, identified by the integer `i`.

   Creates a fresh value, part of this enumeration, identified by the integer `i`.

   i

     An integer that identifies this value at run-time. It must be unique amongst all values of the enumeration.

   returns

     Fresh value identified by `i`.

   Attributes
     protected

9. #### final def Value: Value

   Creates a fresh value, part of this enumeration.

   Creates a fresh value, part of this enumeration.

   Attributes
     protected

10. #### object ValueOrdering extends Ordering[Value]

    An ordering by id for values of this set

11. #### object ValueSet extends Serializable

    A factory object for value sets

12. #### final def apply(x: Int): Value

    The value of this enumeration with given id `x`

13. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

14. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

15. #### def ensuring(cond: (Enumeration) ⇒ Boolean, msg: ⇒ Any): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (Enumeration) ⇒ Boolean): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

21. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Enumeration to StringFormat[Enumeration] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

22. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

23. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()

24. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

25. #### final def maxId: Int

    The one higher than the highest integer amongst those used to identify values in this enumeration.

26. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

27. #### var nextId: Int

    The integer to use to identify the next created value.

    The integer to use to identify the next created value.

    Attributes
      protected

28. #### var nextName: Iterator[String]

    The string to use to name the next created value.

    The string to use to name the next created value.

    Attributes
      protected

29. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

30. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

31. #### def readResolve(): AnyRef

    Attributes
      protected

32. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

33. #### def toString(): String

    The name of this enumeration.

    The name of this enumeration.

    returns

      a String representation of the object.

    Definition Classes
      Enumeration → AnyRef → Any

34. #### def values: ValueSet

    The values of this enumeration as a set.

35. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def withName(s: String): Value

    Return a `Value` from this `Enumeration` whose name matches the argument `s`.

    Return a `Value` from this `Enumeration` whose name matches the argument `s`. The names are determined automatically via reflection.

    s

      an `Enumeration` name

    returns

      the `Value` of this `Enumeration` if its name matches `s`

    Exceptions thrown

      `NoSuchElementException` if no `Value` with a matching name is in this `Enumeration`

39. #### def →[B](y: B): (Enumeration, B)

    Implicit information
      This member is added by an implicit conversion from Enumeration to ArrowAssoc[Enumeration] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Enumeration to any2stringadd[Enumeration]

### Inherited by implicit conversion StringFormat from Enumeration to StringFormat[Enumeration]

### Inherited by implicit conversion Ensuring from Enumeration to Ensuring[Enumeration]

### Inherited by implicit conversion ArrowAssoc from Enumeration to ArrowAssoc[Enumeration]

### Ungrouped